var canvas, context;
var gImage;
var WIDTH, HEIGHT;
var frameRate = 5;
var refreshCount = 0;
var battery;
var currentFrame;
var TIMELINE_MAX_VALUE = 24 * 60 * 60 * frameRate;
var dayOfWeek = ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"];
var dayOfWeekFull = ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"];
var monthStr = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
var monthStrFull = ["January", "Febuary", "March", "April", "May", "Jun", "July", "August", "September", "October", "November", "December"];
var maximumDays = [31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
var img9png = new Image();
var img8png = new Image();
var img3png = new Image();
var img4png = new Image();
var img5png = new Image();
var img7png = new Image();
var img6png = new Image();
var img2png = new Image();
var img10png = new Image();

window.requestAnimationFrame ||
    window.webkitRequestAnimationFrame ||
    window.mozRequestAnimationFrame ||
    window.oRequestAnimationFrame ||
    window.msRequestAnimationFrame ||
    function (/* function */ callback) {
        'use strict';
        window.setTimeout(callback, 1000 / frameRate);
    };

function getDate() {
    'use strict';

    var date;
    try {
        date = tizen.time.getCurrentDateTime();
    } catch (err) {
        console.error('Error: ', err.message);
        date = new Date();
    }

    return date;
}

function findByValue(isTime, array, value) {
    if (isTime) {
        if (value === TIMELINE_MAX_VALUE) {
            value = 0;
        }

        for (var i = 0; i<array.length; i++) {
            if (array[i][0] <= value && array[i][1] > value) {
                return true;
            }
        }
    } else {
        for (var i = 0; i<array.length; i++) {
            if (array[i][0] <= value && array[i][1] >= value) {
                return true;
            }
        }
    }

    return false;
}

function refresh() {
    'use strict';
    //Erase the previous time
    context.clearRect(0, 0, context.canvas.width, context.canvas.height);

    //Import the current time
    var date = getDate();
    var hours = date.getHours();
    var minutes = date.getMinutes();
    var seconds = date.getSeconds();
    var hour = hours + minutes / 60;
    var minute = minutes + seconds / 60;
    var milliseconds = seconds + date.getMilliseconds()/1000.0;
    var frame = parseInt(date.getMilliseconds()/(1000/frameRate));
    var angle;
    var text;
    var extent;
    var nextX;

    hours = hours > 12 ? hours - 12 : hours;
    currentFrame = (date.getHours() * frameRate * 60 * 60) + (minutes * frameRate * 60) + (seconds * frameRate) + frame;
    context.save();

    gImage.src = "Merged_1.png";
    context.drawImage(gImage, 0, 0, 360, 360);
    context.restore();
    context.save();

    angle = (0.000000 + ((720.000000 - 0.000000) * ((hour - 0.000000) / (24.000000 - 0.000000))))*Math.PI/180;
    context.translate(180, 243);
    context.rotate(angle);
    img9png.src = "9.png";
    context.drawImage(img9png, -180, -243, 360, 360);
    context.restore();
    context.save();

    angle = (0.000000 + ((360.000000 - 0.000000) * ((minute - 0.000000) / (60.000000 - 0.000000))))*Math.PI/180;
    context.translate(180, 243);
    context.rotate(angle);
    img8png.src = "8.png";
    context.drawImage(img8png, -180, -243, 360, 360);
    context.restore();
    context.save();

    angle = (0.000000 + ((360.000000 - 0.000000) * ((hour - 0.000000) / (24.000000 - 0.000000))))*Math.PI/180;
    context.translate(131, 230);
    context.rotate(angle);
    img3png.src = "3.png";
    context.drawImage(img3png, -131, -230, 360, 360);
    context.restore();
    context.save();

    angle = (0.000000 + ((360.000000 - 0.000000) * ((hour - 0.000000) / (24.000000 - 0.000000))))*Math.PI/180;
    context.translate(242, 163);
    context.rotate(angle);
    img4png.src = "4.png";
    context.drawImage(img4png, -242, -163, 360, 360);
    context.restore();
    context.save();

    angle = (0.000000 + ((150.000000 - 0.000000) * ((date.getDay() + 1 - 1.000000) / (8.000000 - 1.000000))))*Math.PI/180;
    context.translate(120, 163);
    context.rotate(angle);
    img5png.src = "5.png";
    context.drawImage(img5png, -120, -163, 360, 360);
    context.restore();
    context.save();

    angle = (0.000000 + ((720.000000 - 0.000000) * ((hour - 0.000000) / (24.000000 - 0.000000))))*Math.PI/180;
    context.translate(180, 180);
    context.rotate(angle);
    img7png.src = "7.png";
    context.drawImage(img7png, -180, -180, 360, 360);
    context.restore();
    context.save();

    angle = (0.000000 + ((360.000000 - 0.000000) * ((minute - 0.000000) / (60.000000 - 0.000000))))*Math.PI/180;
    context.translate(180, 180);
    context.rotate(angle);
    img6png.src = "6.png";
    context.drawImage(img6png, -180, -180, 360, 360);
    context.restore();
    context.save();

    angle = (0.000000 + ((360.000000 - 0.000000) * ((seconds - 0.000000) / (60.000000 - 0.000000))))*Math.PI/180;
    context.translate(180, 180);
    context.rotate(angle);
    img2png.src = "2.png";
    context.drawImage(img2png, -180, -180, 360, 360);
    context.restore();
    context.save();

    context.translate(257, 258);
    context.rotate(46.50743575877497*Math.PI/180);
    context.beginPath();
    context.font = "16px Tizen";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#FFFFFF";
    text = date.getDate();
    context.fillText(text, 0, 0);
    context.restore();
    context.save();

    img10png.src = "10.png";
    context.drawImage(img10png, 0, 0, 360, 360);
    context.restore();
    context.save();

    context.restore();
    window.requestAnimationFrame(refresh);
    refreshCount++;
}

window.onload = function () {
    'use strict';
    canvas = document.getElementById('clock');
    console.log('onload called');
    context = canvas.getContext('2d');

    canvas.width = document.width;
    canvas.height = document.height;

    WIDTH = document.width;
    HEIGHT = document.height;

    gImage = new Image();

    battery = navigator.battery || navigator.webkitBattery || navigator.mozBattery;

    //add eventListener for tizenhwkey
    window.addEventListener('tizenhwkey', function (e) {
        if (e.keyName == 'back') {
            try {
                tizen.application.getCurrentApplication().exit();
            } catch (err) {
                console.log('Error: ', err.message);
            }
        }
    });

    window.requestAnimationFrame(refresh);

};
